local ADDON_NAME, dssk = ...

DidSomebodySayKeys_SettingsMixin = {}
local frame = DidSomebodySayKeys_SettingsMixin

function frame:okay()
  dssk.settings.auto_slot = self.cb_auto_slot:GetChecked()
  dssk.settings.announce_new_key = self.cb_announce_new:GetChecked()
  dssk.settings.key_sync = self.cb_key_sync:GetChecked()
  dssk.settings.chat.party.reply = self.chat_response.party:GetChecked()
  dssk.settings.chat.raid.reply = self.chat_response.raid:GetChecked()
  dssk.settings.chat.guild.reply = self.chat_response.guild:GetChecked()
  dssk.settings.chat.party.alts = self.chat_response.party_alts:GetChecked()
  dssk.settings.chat.raid.alts = self.chat_response.raid_alts:GetChecked()
  dssk.settings.chat.guild.alts = self.chat_response.guild_alts:GetChecked()
end

function frame:refresh()
  self.cb_auto_slot:SetChecked(dssk.settings.auto_slot)
  self.cb_announce_new:SetChecked(dssk.settings.announce_new_key)
  self.cb_key_sync:SetChecked(dssk.settings.key_sync)
  self.chat_response.party:SetChecked(dssk.settings.chat.party.reply)
  self.chat_response.raid:SetChecked(dssk.settings.chat.raid.reply)
  self.chat_response.guild:SetChecked(dssk.settings.chat.guild.reply)
  self.chat_response.party_alts:SetChecked(dssk.settings.chat.party.alts)
  self.chat_response.raid_alts:SetChecked(dssk.settings.chat.raid.alts)
  self.chat_response.guild_alts:SetChecked(dssk.settings.chat.guild.alts)
  self:update_alts_options()
end

function frame:default()
  dssk:default_settings()
end

function frame:update_alts_options()
  local cr = self.chat_response
  cr.party_alts:SetEnabled(cr.party:GetChecked())
  cr.raid_alts:SetEnabled(cr.raid:GetChecked())
  cr.guild_alts:SetEnabled(cr.guild:GetChecked())
end

function frame:on_load()
  self.name = ADDON_NAME
  self.version_str:SetText("v" .. GetAddOnMetadata(ADDON_NAME, "Version"))

  local this_frame = self
  local function updt()
    this_frame:update_alts_options()
  end
  self.chat_response.party.click_callback = updt
  self.chat_response.raid.click_callback = updt
  self.chat_response.guild.click_callback = updt

  InterfaceOptions_AddCategory(self)
  dssk.settings_frame = self
end
